/* 
    LCZBY AUTOMORFICZNE
    Micha Witaszek
    dla algorytm.org
*/

//Program sprawdza czy podana liczba o podstawie dziesitnej jest automorficzna

#include <cstdlib>
#include <iostream>

using namespace std;

int main()
{
    unsigned int    //liczby calkowite dodatnie
             n,     // liczba
             m=10,  // podstawa liczby - system dziesitny
             a,b;     // zmienne pomocnicze
    
    cout << "LICZBY AUTOMORFICZNE\n\n";
    cout << "Podaj liczbe calkowita: ";
    cin >> n; //pobieramy liczb
    
    b=m;//ustaw b na warto podstawy liczby 
    while(n>b)//dopki b jest wiksze od badanej liczby
    { 
       b*=m; //przemn b przez podstaw
    }
    
    a = (n*n) % b ; //przypisz do a warto (n^2) mod b
    
    if (a==n) // jeli reszta z dzielenia (n^2) / b jest rwna n, 
              // to badana liczba n jest automorficzna
       cout << "Liczba "<<n<<" jest automorficzna"<<endl;
    else
       cout << "Liczba "<<n<<" nie jest automorficzna"<<endl;
        
    system("PAUSE");
    return EXIT_SUCCESS;
}
